Subject: Re: [mif] Revised DHCPv6 Route Option draft

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 07 Oct 2010 22:35:05 +0200

Le 28/09/2010 10:17, Wojciech Dec a écrit :
> Hello All,
>
> an updated DHCPv6 route option draft has been posted under
> http://tools.ietf.org/html/draft-dec-dhcpv6-route-option-05. This
> draft reflects the DHCPv6 options that the authors jointly agreed on
>  as being necessary in the MIF context, and represents effectively a
>  joint route-option draft as discussed during IETF78.
>
> We kindly ask for review and feedback.

Thanks for asking.

Is this draft considering the residential router to be multi-homed?

(I may be wrong, and this is just comments ok, only about the MIF
motivation).

> The following scenario is used to illustrate the problem as found in
> multi-homed residential access networks.

Ok, residential access networks (like ADSL and/or broadband I presume).
  I don't see the CPE (Customer Premises Equipment) or ADSL router, being
multi-homed.  Mine has a single interface towards the operator.

> In multi-homed networks, a given user's node may be connected to
> more than one gateways.

Is this user's node the PC in residence, like the tablet PC and the
printer?  Or is the user's node the router connecting straight to the
operator?  I believe the former may be multi-homed but the latter not.

> Such connectivity may be realized by means of dedicated physical or
> logical links that may also be shared with other users nodes.

Do you mean the residential router has actually several logical links to
the operator?  (like ATM circuits?)

Alex

---

From: Wojciech Dec <[email-masked]>
Date: Fri, 8 Oct 2010 12:36:22 +0200

> Is this draft considering the residential router to be multi-homed?

It's useful to note that the draft mentions the residential router as an
example, but it is meant to be applicable to any type of multi-homed device
hosting the dhcp client and having the basic routing capabilities

> multi-homed.  Mine has a single interface towards the operator.

While it may have a single physical interface, it's very common for such
devices to have multiple logical L2 interfaces, ie multi-homing. Note that
even a device with a *single* logical L2 interface that connects it to
multiple L3 routers can be modelled as multi-link, an example is that of a
client on a shared VLAN with two connected upstream routers.

-Woj.

> _______________________________________________
> mif mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/mif
>

---

From: Alexandru Petrescu <[email-masked]>
Date: Tue, 12 Oct 2010 08:23:09 +0200

Le 08/10/2010 12:36, Wojciech Dec a écrit :
> devices to have multiple logical L2 interfaces, ie multi-homing.

TO me this is not clear. I think although my box may have several such
egress logical interfaces it looks as if they all have the same IP
address, same default route.

> Note that even a device with a *single* logical L2 interface that
> connects it to multiple L3 routers can be modelled as multi-link, an
> example is that of a client on a shared VLAN with two connected
> upstream routers.

Ok, this is something that is not clear to me, but it may be clear
otherwise.

If you think that DHCPv6 Route Option is useful for the residential
gateway then I am fine with it to be done, regardless whether or not
there are multiple interfaces.  The Route OPtion seems valuable in other 
contexts (non-residential) as well.

Alex

>     [email-masked] <mailto:[email-masked]>

---

From: Wojciech Dec <[email-masked]>
Date: Tue, 12 Oct 2010 10:10:55 +0200

> address, same default route.

I'm sorry, what is "not clear" about your box having multiple egress logical
interfaces?

> contexts (non-residential) as well.

Well, as I said, it's certainly meant to be usable in other contexts and I
believe nothing in the text confines it to a specific one.

-Woj.

---

From: Alexandru Petrescu <[email-masked]>
Date: Tue, 12 Oct 2010 11:09:05 +0200

Le 12/10/2010 10:10, Wojciech Dec a écrit :
> <[email-masked] <mailto:[email-masked]>> wrote:
>
>               I don't see the CPE (Customer Premises Equipment) or ADSL
>         router,
>             being
> I'm sorry, what is "not clear" about your box having multiple egress
> logical interfaces?

My box may have several logical interfaces within, but the box has a
single IP address (_the_ address). This makes unclear the need to
distribute several routes to a box because an address is valid typically
only within a route.

>     there are multiple interfaces.  The Route OPtion seems valuable in
>     other contexts (non-residential) as well.
>
>
> Well, as I said, it's certainly meant to be usable in other contexts and
> I believe nothing in the text confines it to a specific one.

Ok.

Alex

>         [email-masked] <mailto:[email-masked]> <mailto:[email-masked]
>         <mailto:[email-masked]>>
>

---

From: Wojciech Dec <[email-masked]>
Date: Tue, 12 Oct 2010 14:17:52 +0200

> distribute several routes to a box because an address is valid typically

So if box would have multiple interfaces, that all lead to a single IP
interface, the IP interface would have a single L2 identifier. Example: a
routed interface on a multi-port ethernet LAN switch.
Is this what you're describing? If so, and assuming that on the other side
there is a similar device, from an IP routing perspective there really is
one interface, and it is thus of no consequence to the DHCP route option.
Iit's a question of the L2 technology in use to select/use the multiple
interfaces. Personally, I didn't come across this a case discussed so far in
MIF...

-Woj.

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 13 Oct 2010 10:21:34 +0200

Le 12/10/2010 14:17, Wojciech Dec a écrit :
>         <[email-masked]
>         <mailto:[email-masked]>
>         <mailto:[email-masked]
>         <mailto:[email-masked]>>> wrote:
>
>                     (I may be wrong, and this is just comments ok, only
>         about
>                 the MIF
>                     motivation).
>
>                         The following scenario is used to illustrate the
>         problem
>                 as found in
>                     Ok, residential access networks (like ADSL and/or
>         broadband
>                 I presume).
>                 While it may have a single physical interface, it's very
>         common
>                 for such
> interface, the IP interface would have a single L2 identifier. Example:
> a routed interface on a multi-port ethernet LAN switch.
> Is this what you're describing?

Err no, I am describing my ADSL box which has a single WAN interface 
(phone line) on which several ATM circuits each dedicated to different 
things (TV, phone, Internet, more), yet it has a single public IPv4 
address (IPv6 is another thing) on that WAN interface.

That ADSL box is akin to residential gateway.

> If so, and assuming that on the other
> side there is a similar device, from an IP routing perspective there
> really is one interface, and it is thus of no consequence to the DHCP
> route option. Iit's a question of the L2 technology in use to select/use
> the multiple interfaces. Personally, I didn't come across this a case
> discussed so far in MIF...

Yes, this is what I am trying to identify.

REsidential gateway: how does DHCP Route Option and multiple interfaces 
apply to MIF.

Handset device WiFi-3G+: how does DHCP Route Option and multiple 
interfaces apply to MIF.

Alex

>                     Is this user's node the PC in residence, like the
>         tablet PC
>                 and the
>                     operator?  I believe the former may be multi-homed
>         but the
>                 latter not.
>
>                         Such connectivity may be realized by means of
>         dedicated
>                 physical or
>                         logical links that may also be shared with other
>         users
>                 nodes.
>
>
>         <mailto:[email-masked]>> <mailto:[email-masked] <mailto:[email-masked]>
>
>         <mailto:[email-masked] <mailto:[email-masked]>>>
>

---

From: Wojciech Dec <[email-masked]>
Date: Wed, 13 Oct 2010 16:54:41 +0200

On 13 October 2010 10:21, Alexandru Petrescu
<[email-masked]>wrote:

> Err no, I am describing my ADSL box which has a single WAN interface (phone
> line) on which several ATM circuits each dedicated to different things (TV,
> phone, Internet, more), yet it has a single public IPv4 address (IPv6 is
> another thing) on that WAN interface.
>

What you will likely find is that inside the box above one of the following
is in place: 1 VC is routed, others are bridged, or, the 1 VC with the IP
address is both bridged and routed again on a single VC - this is like a
router on a multi-point VLAN. In either case the packets from the single IP
address do not "cross" VCs.
A multi-bridged-VC with single IP is also possible, but more likely on
BRASes (RBE), ie not the clients, and is in factmore like the last example I
gave.

Irrespective of these, I'll repeat that IMO the choice of VC is NOT when
there is a single IP interface, or a single IP next hop, is not an IP
routing decision.

> Handset device WiFi-3G+: how does DHCP Route Option and multiple interfaces
> apply to MIF.
>

Well, IMO, you may be mixing things up a bit. The scenarios you describe is
different from the scenarios I understand MIF to be looking at, and it does
not mean that MIF's scenarios do not cover the above (I believe they do),
ie  neither of these cases translate to the problem that you are posing
which is, given a single possible egress IP interface and a single IP next
hop, which of several L2 (or L1) links to that next hop should be used. The
DHCPv6 route option currently does not claim to address it either.
Other in the MIF may have a different opinion.

-Woj.

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 13 Oct 2010 21:04:34 +0200

Le 13/10/2010 16:54, Wojciech Dec a écrit :
> <[email-masked] <mailto:[email-masked]>
> <[email-masked] <mailto:[email-masked]>
> <mailto:[email-masked]>>
> <mailto:[email-masked]>>>> wrote:
>
> Ok, residential access networks (like ADSL and/or broadband I
> presume). I don't see the CPE (Customer Premises Equipment) or ADSL
> router, being multi-homed.  Mine has a single interface towards the
> operator.
>
>
> While it may have a single physical interface, it's very common for
> such devices to have multiple logical L2 interfaces, ie
> multi-homing.
>
>
> TO me this is not clear. I think although my box may have several
> such egress logical interfaces it looks as if they all have the same
> IP address, same default route.
>
>
> distribute several routes to a box because an address is valid
> typically only within a route.
>
>
> So if box would have multiple interfaces, that all lead to a single
> IP interface, the IP interface would have a single L2 identifier.
> Example: a routed interface on a multi-port ethernet LAN switch. Is
> this what you're describing?
>
>
>  (phone line) on which several ATM circuits each dedicated to
> different things (TV, phone, Internet, more), yet it has a single
> public IPv4 address (IPv6 is another thing) on that WAN interface.
>
> What you will likely find is that inside the box above one of the
> following is in place: 1 VC is routed, others are bridged, or, the 1
> VC with the IP address is both bridged and routed again on a single
> VC - this is like a router on a multi-point VLAN. In either case the
> packets from the single IP address do not "cross" VCs. A
> multi-bridged-VC with single IP is also possible, but more likely on
> BRASes (RBE), ie not the clients, and is in factmore like the last
> example I gave.
>
> Irrespective of these, I'll repeat that IMO the choice of VC is NOT
> when there is a single IP interface, or a single IP next hop, is not
> an IP routing decision.
>
>
>
> If so, and assuming that on the other side there is a similar
> device, from an IP routing perspective there really is one interface,
> and it is thus of no consequence to the DHCP route option. Iit's a
> question of the L2 technology in use to select/use the multiple
> interfaces. Personally, I didn't come across this a case discussed so
> far in MIF...
>
>
> REsidential gateway: how does DHCP Route Option and multiple
> interfaces apply to MIF.
>
> Well, IMO, you may be mixing things up a bit. The scenarios you
> describe is different from the scenarios I understand MIF to be
> looking at, and it does not mean that MIF's scenarios do not cover
> the above (I believe they do), ie  neither of these cases translate
> to the problem that you are posing which is, given a single possible
> egress IP interface and a single IP next hop, which of several L2
> (or L1) links to that next hop should be used. The DHCPv6 route
> option currently does not claim to address it either.

Well, I see and I try to not mix things.

Let me go back.  I raised the multiple-interface-single-IP issue because
I felt that is how residential gateways (ADSL box?) work, not
necessarily because I want it solved.

I am trying to understand what in draft-dec-dhcpv6-route-option-05 makes
it adapted to MIF context.

draft says:
> In multi-homed networks, a given user's node may be connected to more
> than one gateways.

Is that 'user node' the ADSL box?  If yes then I am trying to understand
how it does DHCP, what problems it poses to DHCP that relate to MIF -
multiple interfaces.

You seem to say that the multiple-interface-single-IP issue is not
necessarily an issue addressed by draft-dec-dhcpv6-route-option-05. Ok.

Then what other issue of a multiply-interfaced ADSL box behaviour needs
DHCP Route Option draft?

Reading further through draft:
> A DHCPv6 based solution allows an operator an on demand and node
> specific means of configuring static routing information.

Is this node a multiply-interfaced node?  Multiple _egress_ interfaces?
(be them logical).

Sidenote about 4191; draft says:
> Extensions to the protocol defined in [RFC4191] allow hosts to
> discover the preferences for multiple default routers on a given
> link, as well as any specific routes advertised by these routers.

Yes, but RFC4191 is mainly intended for single-interfaced Hosts: there 
are multiple Routers on a link offering specific and preferred routes to 
a Host which is single-interfaced.  This is not MIF because MIF talks 
multiple interfaces on the node.

But, it sounds illogic to discard 4191 because being single-interface 
(this is MIF) and yet design solutions still for single-interfaced machines.

> Other in the MIF may have a different opinion.

Yes, I am interested to listen to other group member oppinion.

Alex

> Well, as I said, it's certainly meant to be usable in other contexts
> and I believe nothing in the text confines it to a specific one.
>
>
> Ok.
>
> Alex
>
>
> -Woj.
>
>
> Alex
>
>
> -Woj.
>
>
> Do you mean the residential router has actually several logical
> links to the operator?  (like ATM circuits?)
>
> Alex _______________________________________________ mif mailing list
> <mailto:[email-masked] <mailto:[email-masked]>>> <mailto:[email-masked]
> <mailto:[email-masked]> <mailto:[email-masked] <mailto:[email-masked]>>
>
> <mailto:[email-masked] <mailto:[email-masked]> <mailto:[email-masked]
> <mailto:[email-masked]>>>>
>
>

---

From: Wojciech Dec <[email-masked]>
Date: Thu, 14 Oct 2010 09:49:22 +0200

> necessarily an issue addressed by draft-dec-dhcpv6-route-option-05. Ok.

The multiple-interface-single-IP IS covered by the draft in the same way
that an IP route table covers that problem; it allows for a the association
of an IP next hop on a given IP interface. What is NOT covered is the fact
that this IP interface is really some composite of underlying links (hidden
to the IP layer) all leading to the same next hop, which is the case you
appear to have in mind. Just like IP routing does not solve the analogous
problem of "which link to use in an etherchannel", this draft, nor I
understand MIF are working on solving it.

> Then what other issue of a multiply-interfaced ADSL box behaviour needs

I believe that you either have an inaccurate working model of the "ADSL
box", or one that leads to it being a link selection (not IP routing)
problem, eg etherchannel and the like. Feel free to present a write-up.
We're rather confident that the route option draft covers ADSL routers, and
any device capable of simple IP routing.

> Is this node a multiply-interfaced node?  Multiple _egress_ interfaces?

I'm not sure how to make it clearer. Yes, the node *can* be
multiple-interface. Just as it can be a single IP interface with N next hops
(noting that N=1 is a case it also solves), which is a shared-media case.

> Yes, but RFC4191 is mainly intended for single-interfaced Hosts: there are
> multiple Routers on a link offering specific and preferred routes to a Host
> which is single-interfaced.  This is not MIF because MIF talks multiple
> interfaces on the node.
>
> But, it sounds illogic to discard 4191 because being single-interface (this
> is MIF) and yet design solutions still for single-interfaced machines.

I disagree; the solution is based on IP routing and does solve both the case
of multiple IP interfaces, as well as a single IP interface with any number
of IP next hops. What it doesn't solve is a link selection problem, eg which
link of an single IP interface etherchannel link bundle. I suggest that if
you feel strongly about it, this is something you take to the MIF WG on a
separate thread re the current charter, and not as comment on the
route-option draft (which this thread is about).

-Woj.

---

From: Hui Deng <[email-masked]>
Date: Sat, 16 Oct 2010 22:35:13 +0800

Inline please

2010/10/14 Alexandru Petrescu <[email-masked]>

> Yes, I am interested to listen to other group member oppinion

Before going into the detail discussion, just clarify MIF doesn't work on
multiple interfaces only
It does cover only 1 interface but belong to multiple administration domains

The scenario discussed here is different from current MIF-dhcp-route-option
draft targeting.
Current MIF dhcp route draft is targeting one interface, but multiple next
hops scenario.
It also cover multiple interfaces and multiple next hops.

If you are proposing one interface and one next hope, but different low
layer VC connection.
>From the description of current charter discussion
"a combination of physical and virtual interfaces (VPNs or tunnels), "
You may need to comment VC or something else should be added into this
bracket,

For your solution, you may need to specify some lower layer interface ID in
the dhcp route option,
but that would be a seperated draft for the future work.

I kindly invite you to write a draft and present in the next MIF meeting to
have more
discussion on it.

thanks

-Hui

---

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 21 Oct 2010 19:30:13 +0200

Le 16/10/2010 16:35, Hui Deng a écrit :
> Inline please
>
> 2010/10/14 Alexandru Petrescu <[email-masked]
>         <mailto:[email-masked]>>>
>         <mailto:[email-masked]>>>>> wrote:
>
>         more
>     Yes, but RFC4191 is mainly intended for single-interfaced Hosts:
>     there are multiple Routers on a link offering specific and preferred
>     routes to a Host which is single-interfaced.  This is not MIF
>     because MIF talks multiple interfaces on the node.
>
>     But, it sounds illogic to discard 4191 because being
>     single-interface (this is MIF) and yet design solutions still for
>     single-interfaced machines.
>
>
> Before going into the detail discussion, just clarify MIF doesn't work
> on multiple interfaces only

Ah!?  So the "MIF" name is kind of misleading - Multiple Interfaces. 
Should be MIFD? (multiple interfaces and domains)?

> The scenario discussed here is different from current
> MIF-dhcp-route-option draft targeting.
> Current MIF dhcp route draft is targeting one interface, but multiple
> next hops scenario.

Ah ok, MIF dhcp route draft targets one interface and multiple next hop 
scenarios.

In this case it approaches more to the rfc4191 perspective.  But 
technically there are still differences dec-vs-4191 (1) most importantly 
IMHO rfc4191 has a 2bit field of "preference" of routes, whereas 
draft-dec doesn't, despite its "and a host preference value for the 
route." (2) draft-dec seems to communicate too the next-hop gw address 
in addition to a subnet prefix part of the route whereas rfc4191 only 
communicates the subnet prefix part (the next hop address is picked from 
the src address of the RA I believe).

> "a combination of physical and virtual interfaces (VPNs or tunnels), "

VPN and tunnel interfaces are two specific cases of virtual interfaces 
and are not ATM circuits nor VCs.

Neither ATM circuits nor VCs (Virtual Circuits?) are virtual interfaces 
(or am I wrong?).

> You may need to comment VC or something else should be added into this

Right... provided I knew what VC were.

> For your solution, you may need to specify some lower layer interface ID
> in the dhcp route option,
> I kindly invite you to write a draft and present in the next MIF meeting
> to have more
> discussion on it.

Ah, I just read this part now.

I have to write something about DHCPv6 and default route, but not yet 
sure where when how to do it.

I do not yet understand how multiple interfaces are necessary to DHCPv6 
default routes.

Alex

---

From: Hui Deng <[email-masked]>
Date: Fri, 29 Oct 2010 23:44:14 +0800

inline please

2010/10/22 Alexandru Petrescu <[email-masked]>

>>        wrote:
> Ah!?  So the "MIF" name is kind of misleading - Multiple Interfaces. Should
> be MIFD? (multiple interfaces and domains)?

Normally we say multiple domains

> IMHO rfc4191 has a 2bit field of "preference" of routes, whereas draft-dec
> doesn't, despite its "and a host preference value for the route." (2)
> draft-dec seems to communicate too the next-hop gw address in addition to a
> subnet prefix part of the route whereas rfc4191 only communicates the subnet
> prefix part (the next hop address is picked from the src address of the RA I
> believe).

if you come to next mif meeting in beijing, as you may see the recharter
discussion about difference from RFC 4191
will be done again, it will be more than this.

> VPN and tunnel interfaces are two specific cases of virtual interfaces and
> are not ATM circuits nor VCs.
>
> Neither ATM circuits nor VCs (Virtual Circuits?) are virtual interfaces (or
> am I wrong?).

you are correct, they are not virtual interface. kind of physical interface?

> I have to write something about DHCPv6 and default route, but not yet sure
> where when how to do it.
>
so you believe multiple interfaces are necessary to dhcp route but not
default routes?

-Hui

---

From: Alexandru Petrescu <[email-masked]>
Date: Sat, 30 Oct 2010 17:44:44 +0200

Le 29/10/2010 17:44, Hui Deng a écrit :
[...]
>> I do not yet understand how multiple interfaces are necessary to
>> DHCPv6 default routes.
>
> so you believe multiple interfaces are necessary to dhcp route but
> not default routes?

In a sense yes: I think dhcp route extensions are more necessary (than
default route) in a multiply-interfaced Host.  I don't see how the
default route extension of dhcp is necessary for a multiply-interfaced Host.

I can not understand a DHCP Server/Relay connected on interface1 of Host
to tell its default route should be the other interface2.

A multiply-interfaced Host would connect to two different domains whose
DHCP Servers couldn't know each other.  It would be difficult for one
DHCP Server of one domain to indicate Host what to do in the other domain.

Alex

> thanks -Hui